<?php

namespace App\Http\Controllers\api;

use App\Http\Controllers\Controller;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Hash;
use DB;
use Carbon\Carbon;
use Response;
use Illuminate\Support\Facades\Validator;

class LedgerController extends Controller
{
    public function AddLedger(Request $request){

        $validator=Validator::make($request->all(),[
            'vch_type' => 'required',
            'vch_no' => 'required',
        ]);

        if($request->vch_type=="sale"){
            $validator=Validator::make($request->all(),[
            'particulars' => 'required',
            'debit' => 'required',
            'user_id' => 'required',
            'particulars' => 'required',
            // 'balance' => 'required',
        ]);
        }
        else if($request->vch_type=="receipt"){
            $validator=Validator::make($request->all(),[
            'particulars' => 'required',
            'credit' => 'required',
            'user_id' => 'required',
            'particulars' => 'required',
            // 'balance' => 'required',
        ]);
        }
        else if($request->vch_type=="journal"){
            $validator=Validator::make($request->all(),[
            'particulars' => 'required',
            'credit' => 'required',
            'user_id' => 'required',
            'particulars' => 'required',
            // 'balance' => 'required',
        ]);
        }
        if($validator->fails()){
            return response()->json(["status"=>false,"message"=>$validator->errors()->first()]);
        }

        $user = DB::table('user_account_of')->where('id', $request->user_id)->first();

        if (!$user) {
            return response()->json(['message' => 'User not found'], 404);
        }

        if($request->vch_type=="sale"){
            $data= array(
            'vch_type'=>$request->vch_type,
            'vch_no'=>$request->vch_no,
            "particulars"=>$request->particulars,
            "debit"=>$request->debit,
            "user_id"=>$request->user_id,
            "balance"=>$request->balance,
            "credit"=>null,
            );
        }else if($request->vch_type=="receipt"){
            $data= array(
                'vch_type'=>$request->vch_type,
                'vch_no'=>$request->vch_no,
                "particulars"=>$request->particulars,
                "credit"=>$request->credit,
                "user_id"=>$request->user_id,
                "balance"=>$request->balance,
                "debit"=>null,
                );
        }else if($request->vch_type=="journal"){
            $data= array(
                'vch_type'=>$request->vch_type,
                'vch_no'=>$request->vch_no,
                "particulars"=>$request->particulars,
                "credit"=>$request->credit,
                "user_id"=>$request->user_id,
                "balance"=>$request->balance,
                "debit"=>null,
                );
        }

        $insertChat= DB::table("ledger_table")->insert($data);
       
        if($insertChat)
        {
        return response()->json(["status"=>true,'message' => 'Ledger Added successfully', 'data' => $data], 200);
        }else{
            return response()->json(["status"=>true,'message' => 'Ledger Added unsuccessfully'], 201);
        } 
    }

    public function FetchLedger(Request $request){
    
        $validator= Validator::make($request->all(),[
            "user_id"=>"required",
            "start_date" => "nullable|date_format:d-m-Y",
            "end_date" => "nullable|date_format:d-m-Y"
            ]);
        if($validator->fails()){
            return response()->json(["status"=>false,"message"=>$validator->errors()->first()]);
        }

        $user = DB::table('user_account_of')->where('id', $request->user_id)->first();

        if (!$user) {
            return response()->json(['message' => 'User not found'], 404);
        }else{
            $query = DB::table("ledger_table")->where('user_id', $request->user_id);
            // $users= DB::table("ledger_table")->where('user_id',$request->user_id)->get();
            
             if ($request->has('start_date')) {
                $startDate = Carbon::createFromFormat('d-m-Y', $request->start_date)->format('Y-m-d');
                $query->where('date', '>=', $startDate);
                
            }
        
              
            if ($request->has('end_date')) {
                
                     $endDate = Carbon::createFromFormat('d-m-Y', $request->end_date)->addDay()->format('Y-m-d');
                    // $endDate = Carbon::createFromFormat('d-m-Y', $request->end_date)->format('Y-m-d');
                    $query->where('date', '<=', $endDate);
            }
            
             $users = $query->get();
            
            
            if($users){
                $totalCreditAmount = $users->sum('credit');
                $totaldebitAmount = $users->sum('debit');
                $totalDiffrenceAmount = $totaldebitAmount-$totalCreditAmount;
                $resultArray=["status"=>true,"total_credit_amount" => "$totalCreditAmount","totaldebitAmount" => "$totaldebitAmount","totalDiffrenceAmount" => "$totalDiffrenceAmount","data"=>$users];
            }else{
                $resultArray=["status"=>false,"message"=>"failed to get your ledger list, please contact your technical support"];
            }
        }
        return response()->json($resultArray);
    }

    public function EditLedger(Request $request){

        $validator=Validator::make($request->all(),[
            'vch_type' => 'required',
            'vch_no' => 'required',
        ]);

        if($request->vch_type=="sale"){
            $validator=Validator::make($request->all(),[
            'particulars' => 'required',
            'debit' => 'required',
            'user_id' => 'required',
            'particulars' => 'required',
            // 'balance' => 'required',
        ]);
        }
        else if($request->vch_type=="receipt"){
            $validator=Validator::make($request->all(),[
            'particulars' => 'required',
            'credit' => 'required',
            'user_id' => 'required',
            'particulars' => 'required',
            // 'balance' => 'required',
        ]);
        }
        else if($request->vch_type=="journal"){
            $validator=Validator::make($request->all(),[
            'particulars' => 'required',
            'credit' => 'required',
            'user_id' => 'required',
            'particulars' => 'required',
            // 'balance' => 'required',
        ]);
        }
        if($validator->fails()){
            return response()->json(["status"=>false,"message"=>$validator->errors()->first()]);
        }

        $user = DB::table('user_account_of')->where('id', $request->user_id)->first();

        if (!$user) {
            return response()->json(['message' => 'User not found'], 404);
        }

        $ledger_id = DB::table('ledger_table')->where('id', $request->id)->first();

        if (!$ledger_id) {
            return response()->json(['message' => 'Ledger not found'], 404);
        }

        $ledger=$request->id;

        if($request->vch_type=="sale"){
            $data= array(
            'vch_type'=>$request->vch_type,
            'vch_no'=>$request->vch_no,
            "particulars"=>$request->particulars,
            "debit"=>$request->debit,
            "user_id"=>$request->user_id,
            "balance"=>$request->balance,
            "credit"=>null,
            );
        }else if($request->vch_type=="receipt"){
            $data= array(
                'vch_type'=>$request->vch_type,
                'vch_no'=>$request->vch_no,
                "particulars"=>$request->particulars,
                "credit"=>$request->credit,
                "user_id"=>$request->user_id,
                "balance"=>$request->balance,
                "debit"=>null,
                );
        }else if($request->vch_type=="journal"){
            $data= array(
                'vch_type'=>$request->vch_type,
                'vch_no'=>$request->vch_no,
                "particulars"=>$request->particulars,
                "credit"=>$request->credit,
                "user_id"=>$request->user_id,
                "balance"=>$request->balance,
                "debit"=>null,
                );
        }

        $insertChat= DB::table("ledger_table")->where('id',$ledger)->update($data);
        return response()->json(["status"=>true,'message' => 'Ledger Updated successfully', 'data' => $data], 200);

    }
    

}
