<?php

namespace App\Http\Controllers\api;

use App\Http\Controllers\Controller;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Hash;
use DB;
use Illuminate\Support\Carbon;
use Response;
use Illuminate\Support\Facades\Validator;

class UnitController extends Controller
{
    public function AddUnit(Request $request){
    
        $validator=Validator::make($request->all(),[
            'date' => 'required',
            'user_id'=>'required',
            'status'=>'required',
        ]);
        if($request->status=="morning"){
            $validator=Validator::make($request->all(),[
            'sf_unit_morning' => 'required',
            'gf_unit_morning' => 'required',
            'gf_dg_unit_morning' => 'required',
            'ca_unit_morning' => 'required',
            'ca_dg_unit_morning' => 'required',
        ]);
        }
        else if($request->status=="evening"){
            $validator=Validator::make($request->all(),[
            'sf_unit_evening' => 'required',
            'gf_unit_evening' => 'required',
            'gf_dg_unit_evening' => 'required',
            'ca_unit_evening' => 'required',
            'ca_dg_unit_evening' => 'required',
        ]);
        }
       
       if($validator->fails()){
            return response()->json(["status"=>false,"message"=>$validator->errors()->first()]);
        }
        
        $exist_user_time =DB::table("units")->where('user_id',$request->user_id)->where('date',$request->date)->get();
        // dd($exist_user_time);
        if ($exist_user_time) {
            $exist_user_time_item = $exist_user_time[0];
            $id = $exist_user_time_item->id;
            if($request->status=="morning"){
                if ($exist_user_time_item->status_morning == 'true') {
                    return response()->json(["status"=>true,'message' => 'Units already saved'], 201);
                } else {
                     $currentDateTime = Carbon::now();
        
                       if($request->status=="morning"){
                            $data= array(
                            'user_id'=>$request->user_id,
                            "sf_unit_morning"=>$request->sf_unit_morning,
                            "gf_unit_morning"=>$request->gf_unit_morning,
                            "gf_dg_unit_morning"=>$request->gf_dg_unit_morning,
                            "ca_unit_morning"=>$request->ca_unit_morning,
                            'ca_dg_unit_morning' => $request->ca_dg_unit_morning,
                            'status_morning'=>'true',
                            'date'=>$request->date,
                            'date_moraning_update' =>$currentDateTime,
                            );
                        }
                         $insertChat= DB::table("units")->where('id',$id)->update($data);
            
                        if($insertChat)
                            {
                            return response()->json(["status"=>true,'message' => 'Units Added successfully', 'data' => $data], 200);
                            }else{
                                return response()->json(["status"=>true,'message' => 'Units Added unsuccessfully'], 201);
                            } 
                }
            } else if($request->status=="evening"){
                if ($exist_user_time_item->status_evening == 'true') {
                    return response()->json(["status"=>true,'message' => 'Units already saved'], 201);
                } else {
                      $currentDateTime = Carbon::now();
                          if($request->status=="evening"){
                                $data=array(
                                'user_id' => $request->user_id, 
                                'sf_unit_evening' => $request->sf_unit_evening,
                                'gf_unit_evening' => $request->gf_unit_evening,
                                'gf_dg_unit_evening' => $request->gf_unit_evening,
                                'ca_unit_evening' => $request->ca_unit_evening,
                                'ca_dg_unit_evening' => $request->ca_dg_unit_evening,
                                'status_evening'=>'true',
                                'date'=>$request->date,
                                'date_evening_update' =>$currentDateTime,
                                
                            );
                            }
                            $insertChat= DB::table("units")->where('id',$id)->update($data);
            
                            if($insertChat)
                                {
                                return response()->json(["status"=>true,'message' => 'Units Added successfully', 'data' => $data], 200);
                                }else{
                                    return response()->json(["status"=>true,'message' => 'Units Added unsuccessfully'], 201);
                                }
            }
        }
        }
        else {
            $currentDateTime = Carbon::now();
        
           if($request->status=="morning"){
                $data= array(
                'user_id'=>$request->user_id,
                "sf_unit_morning"=>$request->sf_unit_morning,
                "gf_unit_morning"=>$request->gf_unit_morning,
                "gf_dg_unit_morning"=>$request->gf_dg_unit_morning,
                "ca_unit_morning"=>$request->ca_unit_morning,
                'ca_dg_unit_morning' => $request->ca_dg_unit_morning,
                'status_morning'=>'true',
                'date'=>$request->date,
                'date_moraning_update' =>$currentDateTime,
                );
            
            }
            else if($request->status=="evening"){
                $data=array(
                'user_id' => $request->user_id, 
                'sf_unit_evening' => $request->sf_unit_evening,
                'gf_unit_evening' => $request->gf_unit_evening,
                'gf_dg_unit_evening' => $request->gf_unit_evening,
                'ca_unit_evening' => $request->ca_unit_evening,
                'ca_dg_unit_evening' => $request->ca_dg_unit_evening,
                'status_evening'=>'true',
                'date'=>$request->date,
                'date_evening_update' =>$currentDateTime,
                
            );
            }
            
            $insertChat= DB::table("units")->insert($data);
            
            if($insertChat)
                {
                return response()->json(["status"=>true,'message' => 'Units Added successfully', 'data' => $data], 200);
                }else{
                    return response()->json(["status"=>true,'message' => 'Units Added unsuccessfully'], 201);
                } 
        }
        
    }

}
