<?php

use Illuminate\Http\Request;
use Illuminate\Support\Facades\Route;
use App\Http\Controllers\api\UserController;
use App\Http\Controllers\api\LedgerController;

/*
|--------------------------------------------------------------------------
| API Routes
|--------------------------------------------------------------------------
|
| Here is where you can register API routes for your application. These
| routes are loaded by the RouteServiceProvider and all of them will
| be assigned to the "api" middleware group. Make something great!
|
*/

Route::middleware('auth:sanctum')->get('/user', function (Request $request) {
    return $request->user();
});

//UserController
Route::post('user_register',[UserController::class,"UserRegister"]);
Route::post('user_login',[UserController::class,"UserLogin"]);
Route::post('add_user_account_of',[UserController::class,"AddUserAccountOf"]);
Route::post('fetch_user_account_of',[UserController::class,"fetchUserAccountOf"]);
Route::get('search_client',[UserController::class,"SearchClient"]);

//LedgerController
Route::post('add_ledger',[LedgerController::class,"AddLedger"]);
Route::post('fetch_ledger',[LedgerController::class,"FetchLedger"]);
Route::post('edit_ledger',[LedgerController::class,"EditLedger"]);